"""Optimization and benchmark functions.

This module contains a collection of optimization and benchmark functions, which
are used to test optimization algorithms. The functions are implemented as
Python functions, and are vectorized to accept NumPy arrays as input.

The functions are taken from the following references:

1.  Surjanovic, S. & Bingham, D. (2013). Virtual Library of Simulation Experiments:
    Test Functions and Datasets. Retrieved January 4, 2023,
    from http://www.sfu.ca/~ssurjano.
2.  Wikipedia contributors. (2021). Test functions for optimization.
    Retrieved January 4, 2023, from
    https://en.wikipedia.org/wiki/Test_functions_for_optimization.
"""
